import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Ammo here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ammo extends ActionActor
{
    int ammoType = 0;
    int ammoAmount = 0;
    String[] gunNames = {"Pistol","Magnum","M16","Shotgun"};
    int[] textOffset = {13,19,43,42};
    StaticImage gunImage;
    boolean pickedUp = false;
    int alpha  = 344;
    
    public Ammo(int amount,int type){
        ammoAmount = amount;
        ammoType = type;
        if(Math.random()>.5){
            getImage().mirrorHorizontally();
        }
        if(Math.random()>.5){
            getImage().mirrorVertically();
        }
    }
    
    public void act() 
    {
        super.act();
        if(pickedUp){
            alpha -= 2;
            if(alpha<255){
                gunImage.getImage().setTransparency(alpha);
            }
            if(alpha%20 == 0){
                gunImage.move(0,-1);
            }
            if(alpha==0){
                world.removeObject(gunImage);
                world.removeObject(this);
            }
        }   
    }    
    
    public boolean action(int a){
        actionNumber = a;
        switch(a){
            case 1: pickUp();return true;
        }
        return false;
    }
    
    public void pickUp(){
        if(pickedUp){
            return;
        }
        gunImage = new StaticImage(new GreenfootImage("Items/" + gunNames[ammoType] + ".bmp"));
        gunImage.getImage().setColor(Color.white);
        gunImage.getImage().drawString("+" + ammoAmount,textOffset[ammoType],10);
        world.character.extraAmmo[ammoType] += ammoAmount;
        getImage().clear();
        world.addObject(gunImage,myX,myY);
        pickedUp = true;
        Greenfoot.playSound("Weapons/AmmoPickup.mp3");
    }
}
