import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class AnimatedLight here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AnimatedShadow extends ActionActor
{
    //GreenfootImage image = new GreenfootImage(40,40);
    double[][] coordinates;
    int[][] convertedCoordinates;
    int type = 0;
    StaticLight parentLight;
    float brightness = 0.5f;
            //0 = rotating fan
            
    //type 0 
        double shadowAngle = 0;
        double fanAngle = 0;
        double fanSpeed = 0;
        int spokeNumber;
            
    public AnimatedShadow(int r,int between, double ang,double sp,double r1,double r2,float br,StaticLight l){
        parentLight = l;
        parentLight.animatedShadow = this;
        brightness = br;
        spokeNumber = r;
        ang = ang/180*Math.PI;
        type = 0;
        coordinates = new double[2][r*4+between*r];
        convertedCoordinates = new int[2][r*4+between*r];
        double angle = 0;
        double inr = r1;
        double outr = r2;
        fanSpeed = sp;
        for(int i=0;i<r*4+between*r;i += 4+between){
            coordinates[0][i] = Math.cos(angle)*inr;
            coordinates[1][i] = Math.sin(angle)*inr;
            coordinates[0][i+1] = Math.cos(angle)*outr;
            coordinates[1][i+1] = Math.sin(angle)*outr;

            for(int j=0;j<between;j++){
                coordinates[0][i+2+j] = Math.cos(angle + ang*(j+.5)/between)*outr;
                coordinates[1][i+2+j] = Math.sin(angle + ang*(j+.5)/between)*outr; 
            }
            
            
            coordinates[0][i+2+between] = Math.cos(angle+ang)*outr;
            coordinates[1][i+2+between] = Math.sin(angle+ang)*outr;
            coordinates[0][i+3+between] = Math.cos(angle+ang)*inr;
            coordinates[1][i+3+between] = Math.sin(angle+ang)*inr;
            angle += Math.PI*2/r;
        }
    }
    
    
    
    public void act() 
    {
        fanAngle += fanSpeed;
        for(int i=0;i<coordinates[0].length;i++){
            double x = coordinates[0][i]*Math.cos(fanAngle) - coordinates[1][i]*Math.sin(fanAngle);
            double y = coordinates[1][i]*Math.cos(fanAngle) + coordinates[0][i]*Math.sin(fanAngle);
            
            convertedCoordinates[0][i] = (int)(x+myX-world.tilex);
            convertedCoordinates[1][i] = (int)(y+myY-world.tiley);
           
        }
        move(0,0);
        super.act();
        //world.shadowBuffer2.fillPolygon(convertedCoordinates[0],convertedCoordinates[1],24);
    }    

}
