import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Mrfriendly here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MrFriendly  extends Character
{
    bodyPartBelow tl;   //thigh left
    bodyPartBelow tr;   //thigh right
    bodyPartBelow ll;   //leg left
    bodyPartBelow lr;   //leg right
    bodyPartBelow al;   //arm left
    bodyPartBelow ar;   //arm right
    bodyPartBelow cl;   //claw left
    bodyPartBelow cr;   //claw right
    
    bodyPartAbove h;    //head
    bodyPartAbove j;    //jaw
    
    double inc = 0;
    
    int mx,my;
    double mang;
    double ang;
    double velx,vely;
    
    int state = 0;      //0 running: 1 attacking: 2 jumping
    int counter = 0;
    
    public MrFriendly(){
        super(0,0);      
        tl = new bodyPartBelow(this,0,-5,"Monsters/MrFriendly/Thigh.bmp");
        ll = new bodyPartBelow(tl,0,-6,"Monsters/MrFriendly/LegL.bmp");
        tr = new bodyPartBelow(this,0,-5,"Monsters/MrFriendly/Thigh.bmp");
        lr = new bodyPartBelow(tr,0,-6,"Monsters/MrFriendly/LegR.bmp");
        
        al = new bodyPartBelow(this,0,6,"Monsters/MrFriendly/Thigh.bmp");
        cl = new bodyPartBelow(al,0,6,"Monsters/MrFriendly/ArmL.bmp");
        ar = new bodyPartBelow(this,0,6,"Monsters/MrFriendly/Thigh.bmp");
        cr = new bodyPartBelow(ar,0,6,"Monsters/MrFriendly/ArmR.bmp");
        
        h = new bodyPartAbove(this,0,5,"Monsters/MrFriendly/Head.bmp");
        j = new bodyPartAbove(h,0,0,"Monsters/MrFriendly/Jaw.bmp");
        clearImage();
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);    
        world.addObject(tl,myX-3,myY-5);
        world.addObject(ll,myX-3,myY-16);
        world.addObject(tr,myX+3,myY-5);
        world.addObject(lr,myX+3,myY-16);
        
        world.addObject(al,myX-3,myY+2);
        world.addObject(cl,myX-3,myY+14);
        world.addObject(ar,myX+3,myY+2);
        world.addObject(cr,myX+3,myY+14);
        
        world.addObject(h,myX,myY+7);
        world.addObject(j,myX,myY+13);    
    }
    
    
    public void act() 
    {
        move(0,0);
        if(destX.size()!=0){
            super.act();
            return;
        }
        

        if(state == 0){
            run();
        }
        if(state == 1){
            attack();
        }
        if(state == 2){
            jump();
        } 
        
        
        //h.rotate(.04);
        h.setLocalRotation(-Math.sin(inc)*.2);
        super.act();
    }    
    
    public double swing(double a){
        a = a%(Math.PI*2);
        return Math.cos(a+Math.sin(a/2));
    }
    
    public double distAng(double a,double b){
        while(Math.abs(a-b)>Math.PI){
            if(a<b){
                a+=Math.PI*2;
            }else{
                a-=Math.PI*2;
            }
        }
        return b-a;
    }
    
    public void run(){
        seek(world.tilex+200,world.tiley+200,1.3);
    }
    
    public void seek(double dx,double dy,double s){     
        mang = Math.atan2(myY-dy,myX-dx);
        double deltaAng = 0;
        if(Math.abs(distAng(ang,mang))>Math.PI/4){
            deltaAng = .04;
            velx *= .9;
            vely *= .9;
            inc += .15;
        }else{
            deltaAng = .03;
            velx += (-Math.cos(ang)*s - velx)/10;
            vely += (-Math.sin(ang)*s - vely)/10;
            inc += .2;
        }
        
        if(distAng(ang,mang)>0){
            ang += deltaAng;
        }else{
            ang -= deltaAng;
        }
        
        double distToPlayer = distTo(dx,dy);
        if(distToPlayer<300   &&  distToPlayer>100  && Math.abs(distAng(ang,mang))<Math.PI/10){
            counter++;
            if(counter==60){
                state = 2;
                counter = 0;
                while(inc > Math.PI*2){
                    inc -= Math.PI*2;
                }
                
            }
        }else{
            counter = 0;
        }
        
        al.setLocalRotation(swing(inc)*.8+1.7);
        cl.setLocalRotation(swing(inc-2.1)*1.2-1.7);
        
        ar.setLocalRotation(-swing(inc+Math.PI)*.8-1.7);
        cr.setLocalRotation(-swing(inc-2.1+Math.PI)*1.2+1.7);
        
        tl.setLocalRotation(swing(inc)-.8);
        ll.setLocalRotation(-swing(inc-.8)*1.1+1);
        
        tr.setLocalRotation(-swing(inc+Math.PI)+.8);
        lr.setLocalRotation(swing(inc-.8+Math.PI)*1.1-1);
        setLocalRotation(Math.sin(inc)*.2+ang+Math.PI/2); 
        
        if(distToPlayer < 30){
            state = 1;
        }
        j.setImageOffset(0,3*Math.cos(inc*2)+3);
        move(velx,vely);
    }
    
    
    public void jump(){
        counter++;
        
        if(counter<30){
            inc += (Math.PI - inc)/20;
            velx *= .94;
            vely *= .94;
            ang = mang;
            setLocalRotation(ang+Math.PI/2);
        }else{
            inc += (.4-inc)/10;
            velx += (-Math.cos(ang)*6 - velx)/3;
            vely += (-Math.sin(ang)*6 - vely)/3;
            if(Math.pow(getX()-mx,2)+Math.pow(getY()-my,2) < 1000  || counter == 60){
                state = 0;
            }
        }
        
        al.setLocalRotation(swing(inc)*.8+1.7);
        cl.setLocalRotation(swing(inc-1.4)*1.2-.7);
        
        ar.setLocalRotation(-swing(inc)*.8-1.7);
        cr.setLocalRotation(-swing(inc-1.4)*1.2+.7);
        
        tl.setLocalRotation(swing(inc)-.8);
        ll.setLocalRotation(-swing(inc-.8)*1.1+1);
        
        tr.setLocalRotation(-swing(inc)+.8);
        lr.setLocalRotation(swing(inc-.8)*1.1-1);
        move(velx,vely);
    }
    
    public void attack(){
        velx = 0;
        vely = 0;
        tl.setLocalRotation(-1.2);
        ll.setLocalRotation(1);
        tr.setLocalRotation(1.2);
        lr.setLocalRotation(-1);
        
        inc += .23;
        
        al.setLocalRotation(swing(inc)*.8+1);
        cl.setLocalRotation(swing(inc-1.4)*1.2-.7);
        
        ar.setLocalRotation(-swing(inc+Math.PI)*.8-1);
        cr.setLocalRotation(-swing(inc-1.4+Math.PI)*1.2+.7);
        
        if(distAng(ang,mang)>0){
            ang += .05;
        }else{
            ang -= .05;
        }
        setLocalRotation(ang+Math.PI/2);
        if(Math.pow(getX()-mx,2)+Math.pow(getY()-my,2) > 2000){
            state = 0;
        }
        j.setImageOffset(0,3*Math.cos(inc*4)+3);
        move(velx,vely);
    }
    
    public double dist(double a,double b){
        return Math.sqrt(a*a+b*b);
    }
    
    public boolean isNear(){
        return Math.abs(myX-destX.get(0))<5   &&  Math.abs(myY-destY.get(0))<5;
    }
}
