import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


public class Pressable  extends Actor
{
    boolean isPressed = false;
    boolean isUp = true;
    boolean isDown = false;
    boolean isReleased = false;
    boolean isOver = false;
    MouseInfo mouse;
    int mx,my;
    
    protected void addedToWorld(World world){
        for(int i=0;i<getImage().getWidth();i++){
            for(int j=0;j<getImage().getHeight();j++){
                if(getImage().getColorAt(i,j).equals(Color.white)){
                    getImage().setColorAt(i,j,new Color(0,0,0,0));
                }
            }
        }
    }
    
    public void act() 
    {
        mouse = Greenfoot.getMouseInfo();
        if(mouse!=null){
            mx = mouse.getX();
            my = mouse.getY();
        }
        isOver = false;
        if(mx > getX()-getImage().getWidth()/2  && 
           mx < getX()+getImage().getWidth()/2  &&
           my > getY()-getImage().getHeight()/2  && 
           my < getY()+getImage().getHeight()/2){
               isOver = true;
        }
            
        isPressed = false;
        isReleased = false;
        if(Greenfoot.mousePressed(this)){
            isPressed = true;
            isUp = false;
            isDown = true;
        }
        if(Greenfoot.mouseClicked(null)){
            isReleased = true;   
            isUp = true;
            isDown = false;
        }
    }  

    
}