import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Slider here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Slider  extends Pressable
{
    int max,min,steps,length;
    int start;


    public Slider(int n,int x,int stps){
        max = x;
        min = n;
        steps = stps;
        length = (max-min)/(steps-1);
        start = 0;
    }
    
    public Slider(int n,int x,int stps,int strt){
        max = x;
        min = n;
        steps = stps;
        length = (max-min)/(steps-1);
        start = strt;
    }
    
    protected void addedToWorld(World world){
        super.addedToWorld(world);
        setLocation(min + start*(max-min)/(steps-1),getY());
        if(getX()>max){
            setLocation(max,getY());
        }
        if(getX()<min){
            setLocation(min,getY());
        }
    }
    
    public void act() 
    {
        super.act();
        if(isDown){
            setLocation(((mx-min+length/2)/length*(max-min)/(steps-1)) + min,getY());
            if(getX()>max){
                setLocation(max,getY());
            }
            if(getX()<min){
                setLocation(min,getY());
            }
        }
    }    
    
    public int getStep(){
        return (getX()-min)/((max-min)/(steps-1));
    }
}
