import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


public class TextEntry extends Pressable
{
    GreenfootImage image  = new GreenfootImage(200,20);
    String text;
    String entry = "";
    
    public TextEntry(String t){
        image.setColor(new Color(128,128,128));
        image.fill();
        image.setColor(new Color(50,50,50));
        image.drawRect(0,0,200,20);     
        text = t;
        setImage(image);
        Greenfoot.getKey();
    }
    
    
    public void act() 
    {
        String key = Greenfoot.getKey();
        
        if(key == null){
            key = "";
        }
        if(key.equals("enter")){
            key = "";
        }
        if(key.equals("backspace")){
            if(entry.length()!=0){
                entry = entry.substring(0,entry.length()-1);
            }
        }else{
            entry = entry + key;
        }
        
        
        image.setColor(new Color(128,128,128));
        image.fill();
        image.setColor(new Color(50,50,50));
        image.drawRect(0,0,200,20);    
        image.setColor(Color.black);
        image.drawString(text+" "+entry,2,14);     
    }    
    
    public String getEntry(){
        return entry;
    }
}
