import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class TriggerTimer extends Trigger
{
    int goalTime;
    int timer = 0;
    int myOffset;
    
    public TriggerTimer(int t,int offset ,Actor p){
        goalTime = t;
        timer = goalTime - offset;
        myOffset = offset;
        setParent(p); 
    }
    
    public void act() 
    {
        super.act();
        timer++;
        if(timer%goalTime == 0){
            trigger();
        } 
    }    
    
    public void wake(){
        super.wake();
        timer = goalTime - myOffset;
    }
}
