import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Character here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Zombie extends Character
{
    //Body Parts
    bodyPartBelow f1;
    bodyPartBelow f2;
    bodyPartAbove h;
    bodyPartBelow a1;
    bodyPartBelow a2;
    bodyPartBelow l;
    bodyPartBelow g;
    bodyPartBelow s1;
    bodyPartBelow s2;
    bodyPartBelow h1;
    bodyPartBelow h2;
    
    MouseInfo mouse;
    int mx,my;
    double mang;
    
    double inc = 0;
    double ang;
    double strafe;
    double speed = 0.06;   //should be .2
    double step;
    double travelAng;

    boolean flashlight = false;
    boolean weapon = false;
    
    boolean pressed = false;
    
    boolean usePressed = false;
    Tester tester = new Tester();
    
    double[] shadowX = {-9,9,9,-9};
    double[] shadowY = {-2,-2,2,2};
    int shadow = 2;
    
    double deltaX=0,deltaY=0;
    double destinationX,destinationY;
    double health = 50;
    boolean seenPlayer = false;
    int moanTimer = 300;
    int justS = 0;
    
    double hitC = 0;
    int hitState = 0;
    boolean didHurt = false;

    public Zombie(String type){
        super(0,0);
        setImage(new GreenfootImage("Monsters/Zombie/Body_"+type+".bmp"));
        f1 = new bodyPartBelow(this,0,0,"Monsters/Zombie/Shoe_zombie.bmp");
        f2 = new bodyPartBelow(this,0,0,"Monsters/Zombie/Shoe_zombie.bmp");
        //g = new bodyPartBelow(a1,a+11,b-7,0,-6,"Gun.bmp");
        h = new bodyPartAbove(this,0,0,"Monsters/Zombie/Head_"+type+".bmp");
        s1 = new bodyPartBelow(this,0,-4,"Monsters/Zombie/Arm_zombie.bmp");
        s2 = new bodyPartBelow(this,0,-4,"Monsters/Zombie/Arm_zombie.bmp");
        h1 = new bodyPartBelow(s1,0,-5,"Monsters/Zombie/Hand_zombie.bmp");
        h2 = new bodyPartBelow(s2,0,-5,"Monsters/Zombie/Hand_zombie.bmp");
        
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        world.addObject(f1,myX+6,myY);
        world.addObject(f2,myX-6,myY);
        world.addObject(h,myX,myY);
        world.addObject(s1,myX+9,myY);
        world.addObject(s2,myX-9,myY);
        world.addObject(h1,myX+9,myY-8);
        world.addObject(h2,myX-9,myY-8);
        world.addObject(tester,0,0);
        s1.setLocalRotation(1);
        h1.setLocalRotation(-2.29);
        s2.setLocalRotation(-1);
        h2.setLocalRotation(2.29);
        width = 20;
        height = 20;
    }
    
    
    public int isShadow(){
        return shadow;
    }
    
    public double[] getShadowX(){
        return shadowX;
    }
    
    public double[] getShadowY(){
        return shadowY;
    }
    
    

    public void act() 
    {
        
        if((world.distanceToPlayer(this)<38 || getObjectsInRange(30,Person.class).size()!=0) && hitState==0){
            hitState = Greenfoot.getRandomNumber(2)+1;
        }
        if(hitState != 0){
            velx *= .8;
            vely *= .8;
            hitC += .15;
            if(hitState == 1){
                s1.setLocalRotation(1 + .8*Math.sin(hitC));
                h1.setLocalRotation(-1.1 + 1.2*Math.sin(hitC-1.5));
                rotate(.16*Math.sin(hitC));
            }else{
                s2.setLocalRotation(-1 - .8*Math.sin(hitC));
                h2.setLocalRotation(1.1 - 1.2*Math.sin(hitC-1.5));
                rotate(-.16*Math.sin(hitC));
            }
            if(hitC > 2.9){
                if(hitState == 1){
                    world.addObject(new force(-.5*Math.cos(angle),-.5*Math.sin(angle),true,10),h1.myX + 12*Math.sin(h1.angle),h1.myY - 14*Math.cos(h1.angle));
                }else{
                    world.addObject(new force(.5*Math.cos(angle),.5*Math.sin(angle),true,10),h2.myX + 12*Math.sin(h2.angle),h2.myY - 14*Math.cos(h2.angle));
                }
            }  
            if(hitC > Math.PI*2){
                hitC = 0;
                hitState = 0;
            }
        }
        
        
        
        //s2.setLocalRotation(-.7);
        //h2.setLocalRotation(1.5);
        //s2.rotate(.1);
        //System.out.println(destinationX + " : " + myY);
        if(world.canSeePlayer(myX,myY,6)){
            destinationX = world.tilex+200;
            destinationY = world.tiley+200;
            if(justS>0){
                justS--;
            }
            if(!seenPlayer && justS==0){
                Greenfoot.playSound("Monsters/Zombie/Zombie_alert"+(Greenfoot.getRandomNumber(2)+1)+".mp3");
                justS = 50;
            }
            seenPlayer = true;
            moanTimer--;
            if(moanTimer < 0 && justS==0){
                Greenfoot.playSound("Monsters/Zombie/Zombie_moan"+(Greenfoot.getRandomNumber(3)+1)+".mp3");
                moanTimer = 100 + Greenfoot.getRandomNumber(200);
                justS = 50;
            }
        }else{
            seenPlayer = false;
        }
        seek(destinationX,destinationY,1);
        if(distTo(destinationX,destinationY)<5){
            destinationX = world.tilex+200;
            destinationY = world.tiley+200;
        }
        mouse = Greenfoot.getMouseInfo();
        if(mouse!=null){
            mx = mouse.getX();
            my = mouse.getY();
        }
        
        
        f1.setImageOffset(0,3*Math.sin(inc)-3);
        f2.setImageOffset(0,-3*Math.sin(inc)-3);
        velx += deltaX;
        vely += deltaY;
            
        mang = Math.atan2(my-200,mx-200) + Math.PI/2;
        ang = mang;
        
        if(pressed){
            travelAng = Math.atan2(deltaY,deltaX)+Math.PI/2;
            inc += .2*Math.sqrt(velx*velx + vely*vely);
            double temp = Math.atan2(vely,velx)+Math.PI/2 - ang;
            if(temp>Math.PI)
                temp -= Math.PI*2;
            if(temp<-Math.PI)
                temp += Math.PI*2;
            if(temp>Math.PI)
                temp -= Math.PI*2;
            if(temp<-Math.PI)
                temp += Math.PI*2;
            if(temp<-3*Math.PI/4)
                temp += 5*Math.PI/4;
            if(temp>3*Math.PI/4)
                temp -= 5*Math.PI/4;
            step = temp;
            temp = temp/2;
            temp += ang;
            step = ang;
            ang = temp;
        }else{
            inc += (-inc)/15;
            step = ang;
        }
        if(inc>Math.PI*2)
            inc -= Math.PI*2;
            
        
        if(Math.abs(angle-(Math.PI*2+ang)) < Math.abs(angle-ang)){
            ang = ang+Math.PI*2;
        }
        if(Math.abs(angle-(-Math.PI*2+ang)) < Math.abs(angle-ang)){
            ang = ang-Math.PI*2;
        }

        //setRotation(ang/2);
        if(Math.abs(angle-(Math.PI*2+mang)) < Math.abs(angle-mang)){
            mang = mang+Math.PI*2;
        }
        if(Math.abs(angle-(-Math.PI*2+mang)) < Math.abs(angle-mang)){
            mang = mang-Math.PI*2;
        }    
        
        strafe = .4*Math.sin(inc);
        towards(strafe+travelAng);
        h.setRotation(angle);
        //s2.setOffset(0,-2.5*Math.sin(inc)-2);
          
        if(angle>Math.PI/2)
            angle -= 2*Math.PI;
        if(angle<-Math.PI)
            angle += 2*Math.PI;

        pressed = false;
        deltaX=0;
        deltaY=0;  
        super.act();
    } 
    
    public void towards(double tang){
       if(Math.abs(angle-(Math.PI*2+tang)) < Math.abs(angle-tang)){
           tang = tang+Math.PI*2;
       }
       if(Math.abs(angle-(-Math.PI*2+tang)) < Math.abs(angle-tang)){
           tang = tang-Math.PI*2;
       } 
       rotate((tang - angle)/8);
    }
    
    public void seek(double a,double b,double s){
        pressed = true;
        double dist = Math.sqrt(Math.pow(myX-a,2)+Math.pow(myY-b,2));
        if(dist>5){
            deltaX = speed*(a-myX)/dist;
            deltaY = speed*(b-myY)/dist;
            //System.out.println(":::"+deltaY);
        }
    }
    
    public boolean isNear(){
        return Math.abs(myX-destX.get(0))<5   &&  Math.abs(myY-destY.get(0))<5;
    }
    
    public void rotateDegrees(double a){
        travelAng = a/180*Math.PI;
    }
    
    public void hurt(double dx,double dy,double mag){
        //velx += dx;
        //vely += dy;
        
        health -= mag;   
        //System.out.println(health);
        Greenfoot.playSound("Materials/flesh_hit_"+(Greenfoot.getRandomNumber(2)+1) + ".mp3");
        if(health <= 0){
            List<Bone> all = getConnectedBones();   
            for(int i=0;i<all.size();i++){
                world.addObject(new shrapnel(all.get(i),0,0,2,false),myX,myY);
            }  
            world.addObject(new BloodSplatter(80,40),myX,myY);
            removeAllBones();
            Greenfoot.playSound("Monsters/Zombie/Zombie_die"+(Greenfoot.getRandomNumber(2)+1)+".mp3");
        }
    }
    
}