import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Character here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bill  extends Character
{
    //Body Parts
    bodyPartBelow f1;
    bodyPartBelow f2;
    bodyPartAbove h;
    bodyPartBelow a1;
    bodyPartBelow a2;
    bodyPartBelow l;
    bodyPartBelow r;
    bodyPartBelow s1;
    bodyPartBelow s2;
    
    //MOUSE DATA
    MouseInfo mouse;
    int mx,my;
    double mang;
    
    //OBJECT WORLD DATA
    double inc = 0;
    double ang;
    double strafe;
    final double maxSpeed = .15;
    double speed = .1;
    double step;
    double travelAng;

    //SHADOW DATA
    boolean flashlight = false;
    double[] shadowX = {-10,10};
    double[] shadowY = {0,0};
    
    //HEALTH DATA
    int health = 60;
    int safeTime = 0;
    
    //OBJECT INTERACTION
    boolean pressed = false;
    boolean usePressed = false;
    Tester tester = new Tester();
    boolean grabbing = false;
    ActionActor grabbedObject;
    boolean hasFlare = false;
    Flare currentFlare = null;
    
    //WEAPONS DATA
    boolean weapon = false;
    int weaponType = 0;
    double axeAnimation = 0;
    int weaponMax = 0;
    float muzzleFlash = 0;
    int ammo[] = {25,6,45,8};
    int extraAmmo[] = {40,6,45,6};
    final static int ammoPerClip[] = {25,6,45,8};
    final static int reloadTime[]  = {5,30,1,30};
    boolean reloadPressed = false;
    
    int reloadTimer = 0;
    int reloadBullets = 0;
   
    
    //WEAPON 4 m16
    boolean shooting = false;
    int shotCooldown = 0;
    int soundCounter = 0;
    GreenfootSound m16shoot = new GreenfootSound("Weapons/M16_Fire.mp3");
    
    GlowingImage muzzleFlashImage = new GlowingImage("MuzzleFlash.png");

    public Bill(){
        super();
        setImage(new GreenfootImage("Characters/Body.bmp"));
        f1 = new bodyPartBelow(this,0,0,"Characters/Shoe.bmp");
        f2 = new bodyPartBelow(this,0,0,"Characters/Shoe.bmp");
        s1 = new bodyPartBelow(this,0,0,"Characters/Shoulder.bmp");
        s2 = new bodyPartBelow(this,0,0,"Characters/Shoulder.bmp");
        h = new bodyPartAbove(this,0,0,"Characters/Head.bmp");
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        world.addObject(f1,myX+6,myY);
        world.addObject(f2,myX-6,myY);
        world.addObject(h,myX,myY);
        world.addObject(s1,myX+11,myY);
        world.addObject(s2,myX-11,myY);
        world.addObject(tester,0,0);
        shadowLevel = 1;
        height = 15;
        width = 15;
    }

    public void act() 
    {
        if(Greenfoot.isKeyDown("t")){
            ammo[0] = 9001;
            ammo[1] = 9001;
            ammo[2] = 9001;
            ammo[3] = 9001;
            switchWeapon(5);
        }
        //inc += .2;
        safeTime--;
        mouse = Greenfoot.getMouseInfo();
        if(mouse!=null){
            mx = mouse.getX();
            my = mouse.getY();
        }
        
        for(int i=1;i<=weaponMax;i++){
            if(Greenfoot.isKeyDown(""+i)){
                switchWeapon(i);
            }
        }
        
        
        f1.setImageOffset(0,6*Math.sin(inc)-1);
        f2.setImageOffset(0,-6*Math.sin(inc)-1);
        boolean pressed = false;
        double deltaX=0,deltaY=0;
        if(Greenfoot.isKeyDown("space")){
            speed = 1;
        }else{
            speed = maxSpeed;
        }
        if(Greenfoot.isKeyDown("d") || Greenfoot.isKeyDown("right")){// || Greenfoot.isKeyDown("right")){
            deltaX = speed;
            pressed = true;
        }
        if(Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("left")){// || Greenfoot.isKeyDown("left")){
            deltaX = -speed;
            pressed = true;
        }
        if(Greenfoot.isKeyDown("w") || Greenfoot.isKeyDown("up")){// || Greenfoot.isKeyDown("up")){
            deltaY = -speed;
            pressed = true;
        }
        if(Greenfoot.isKeyDown("s") || Greenfoot.isKeyDown("down")){// || Greenfoot.isKeyDown("down")){
            deltaY = speed;
            pressed = true;
        }
        velx += deltaX;
        vely += deltaY;
        
        mang = Math.atan2(my-200,mx-200) + Math.PI/2;
        //System.out.println(mang);
        ang = mang;
        
        if(pressed){
            travelAng = Math.atan2(deltaY,deltaX)+Math.PI/2;
            inc += .12*Math.sqrt(velx*velx + vely*vely);
            double temp = Math.atan2(vely,velx)+Math.PI/2 - ang;
            if(temp>Math.PI)
                temp -= Math.PI*2;
            if(temp<-Math.PI)
                temp += Math.PI*2;
            if(temp>Math.PI)
                temp -= Math.PI*2;
            if(temp<-Math.PI)
                temp += Math.PI*2;
            if(temp<-3*Math.PI/4)
                temp += 5*Math.PI/4;
            if(temp>3*Math.PI/4)
                temp -= 5*Math.PI/4;
            step = temp;
            temp = temp/2;
            temp += ang;
            step = ang;
            ang = temp;
        }else{
            inc += (-inc)/15;
            step = ang;
        }
        if(inc>Math.PI*2)
            inc -= Math.PI*2;
            
        
        if(Math.abs(angle-(Math.PI*2+ang)) < Math.abs(angle-ang)){
            ang = ang+Math.PI*2;
        }
        if(Math.abs(angle-(-Math.PI*2+ang)) < Math.abs(angle-ang)){
            ang = ang-Math.PI*2;
        }

        //setRotation(ang/2);
        if(Math.abs(angle-(Math.PI*2+mang)) < Math.abs(angle-mang)){
            mang = mang+Math.PI*2;
        }
        if(Math.abs(angle-(-Math.PI*2+mang)) < Math.abs(angle-mang)){
            mang = mang-Math.PI*2;
        }    
        
        if(flashlight){
            if(angle-mang>0){
                a2.setRotation(mang);
            }else{
                a2.setRotation(angle);
            }
            
            world.setLightShadow((int)myX,(int)myY);
            l.setRotation(Math.atan2(my - l.myY + world.tiley,mx - l.myX + world.tilex)+Math.PI/2);
            world.setLightBeam((int)(l.myX+13*Math.cos(l.angle-Math.PI/2)),
                               (int)(l.myY+13*Math.sin(l.angle-Math.PI/2)),
                               l.angle/Math.PI*180-90);
            double lsx = l.myX,lsy = l.myY;
            strafe = -.4*Math.sin(inc);
            towards(strafe+ang);
            h.setRotation(mang);
        }else{
            strafe = -.4*Math.sin(inc);
            towards(strafe+travelAng);
            h.setRotation(angle);
            s2.setImageOffset(0,3*Math.sin(inc));
            
        }
        
        MouseInfo mouse = Greenfoot.getMouseInfo();
        
        fireWeapon();
        
        
          
        if(angle>Math.PI/2)
            rotate(-2*Math.PI);
        if(angle<-Math.PI)
            rotate(2*Math.PI);

        if(grabbing){
            grabbedObject.grab(r.myX+Math.cos(r.angle-Math.PI/2)*15,
                               r.myY+Math.sin(r.angle-Math.PI/2)*15,
                               r.angle - Math.PI/2);
        }
        if(hasFlare){
            currentFlare.grab( l.myX+Math.cos(l.angle-Math.PI/2)*15,
                               l.myY+Math.sin(l.angle-Math.PI/2)*15,
                               l.angle - Math.PI/2);
            //if(Greenfoot.isKeyDown("q")){
            //    releaseFlare();
            //}
        }
            
        if(Greenfoot.isKeyDown("e") || (Greenfoot.mousePressed(null) && mouse.getButton()==3)){  
            if(usePressed){
                if(grabbing){
                    releaseObject();
                }else{
                    tester.setLocation(200+(int)(20*Math.sin(angle)),200-(int)(20*Math.cos(angle)));
                    if(!tester.test()){
                        if(hasFlare){
                            releaseFlare();
                        }
                    }
                }
            }
            usePressed = false;
        }else{
            usePressed = true;
        }
            
        super.act();
    } 
    
    public void towards(double tang){
       if(Math.abs(angle-(Math.PI*2+tang)) < Math.abs(angle-tang)){
           tang = tang+Math.PI*2;
       }
       if(Math.abs(angle-(-Math.PI*2+tang)) < Math.abs(angle-tang)){
           tang = tang-Math.PI*2;
       } 
       rotate((tang - angle)/8);
    }
    
    public void giveFlashlight(){
        flashlight = true;      
        getWorld().removeObject(s2);
        removeChild(s2);
        a2 = new bodyPartBelow(this,0,-4,"Characters/Arm.bmp");
        l = new bodyPartBelow(a2,0,-7,"Characters/Light.bmp");
        world.addActionActor(a2,myX-11,myY);
        world.addActionActor(l,myX-11,myY-7);
    }
    
    public void giveWeapon(){
        weapon = true;      
        getWorld().removeObject(s1);
        removeChild(s1);
        a1 = new bodyPartBelow(this,0,-4,"Characters/Arm.bmp");
        r = new bodyPartBelow(a1,0,0,"Characters/Weapon_Axe.bmp");
        world.addActionActor(a1,myX+11,myY);
        world.addActionActor(r,myX+11,myY-7);
    }
    
    public void scrollWeapon(int ammount){
        if(weaponMax == 0 || ammount == 0){
            return;
        }
        weaponType += ammount;
        while(weaponType >= weaponMax){
            weaponType -= weaponMax;
        }
        while(weaponType <= 0){
            weaponType += weaponMax;
        }
        switchWeapon(weaponType);
    }
    
    public void fireWeapon(){
        if(Greenfoot.isKeyDown("r")){
            if(!reloadPressed  && weaponType>=2){
                reloadBullets = ammoPerClip[weaponType-2] - ammo[weaponType-2];
                if(reloadBullets > extraAmmo[weaponType-2]){
                    reloadBullets = extraAmmo[weaponType-2];
                }
                reloadTimer = 0;
            }
            reloadPressed = true;
        }else{
            reloadPressed = false;    
        }
        
        if(reloadBullets!=0){
            reloadTimer++;
            if(reloadTimer>reloadTime[weaponType-2]){
                //Greenfoot.playSound("Weapons/Reload_" + Greenfoot.getRandomNumber(3) + ".mp3");
                Greenfoot.playSound("Weapons/Reload_1.mp3");
                ammo[weaponType-2]++;
                extraAmmo[weaponType-2]--;  
                reloadTimer = 0;
                reloadBullets--;
            }
         }
        
        if(weapon){
            switch(weaponType){
                case 1: //*************AXE****************
                    if(angle-mang>0){
                        a1.setRotation(angle+.4*Math.sin(axeAnimation)+.6);
                    }else{
                        a1.setRotation(mang+.4*Math.sin(axeAnimation)+.6);
                    }
                    if(Greenfoot.mousePressed(null) && mouse.getButton()==1 && axeAnimation<.2 && !grabbing){
                        axeAnimation = Math.PI;
                        Greenfoot.playSound("Weapons/Axe_swing.mp3");
                        world.addObject(new force(3*Math.cos(mang-Math.PI/2),3*Math.sin(mang-Math.PI/2),false,10),myX+25*Math.sin(mang),myY-25*Math.cos(mang));
                    }
                    if(axeAnimation>0){
                        if(axeAnimation>Math.PI/2){
                            axeAnimation -= .25;
                        }else{
                            axeAnimation -= .10;
                        }
                    }
                    towards(strafe+ang+2*Math.sin(axeAnimation));
                    r.setLocalRotation(.9*Math.sin(axeAnimation)-1.4); 
                    break;
                case 2://*************PISTOL**************** 
                    r.setRotation(Math.atan2(my - a1.getY(),mx-a1.getX())+Math.PI/2); 
                    if(Greenfoot.mousePressed(null) && mouse.getButton()==1 && !grabbing){
                        if(ammo[0]==0){
                            Greenfoot.playSound("Weapons/Empty.mp3");
                        }else{
                            world.addObject(muzzleFlashImage,r.myX + 20*Math.sin(r.angle),r.myY - 20*Math.cos(r.angle));
                            if(Math.random()>.35){
                                muzzleFlashImage.getImage().mirrorVertically();
                            }
                            muzzleFlashImage.setRotation(r.angle + Math.PI/2);
                            muzzleFlashImage.updateWorldLocation();
                            reloadBullets = 0;
                            muzzleFlash = 1f;                          
                            ammo[0]--;
                            Greenfoot.playSound("Weapons/Pistol_fire.mp3");
                            world.addObject(new bullet(Math.cos(r.angle-Math.PI/2)*15,Math.sin(r.angle-Math.PI/2)*15,7.2),
                                                       r.myX+Math.cos(r.angle-Math.PI/2)*15,
                                                       r.myY+Math.sin(r.angle-Math.PI/2)*15);
                            rotate(.2);
                        }
                    }
                    break;
                case 3://*************MAGNUM****************
                    r.setRotation(Math.atan2(my - a1.getY(),mx-a1.getX())+Math.PI/2); 
                    if(Greenfoot.mousePressed(null) && mouse.getButton()==1 && !grabbing){
                        if(ammo[1]==0){
                            Greenfoot.playSound("Weapons/Empty.mp3");
                        }else{
                            world.addObject(muzzleFlashImage,r.myX + 20*Math.sin(r.angle),r.myY - 20*Math.cos(r.angle));
                            if(Math.random()>.35){
                                muzzleFlashImage.getImage().mirrorVertically();
                            }
                            muzzleFlashImage.setRotation(r.angle + Math.PI/2);
                            muzzleFlashImage.updateWorldLocation();
                            reloadBullets = 0;
                            muzzleFlash = 1f;
                            ammo[1]--;
                            Greenfoot.playSound("Weapons/Magnum_Fire.mp3");
                            world.addObject(new bullet(Math.cos(r.angle-Math.PI/2)*15,Math.sin(r.angle-Math.PI/2)*15,25),r.myX,r.myY);
                            rotate(.6);
                        }
                    }
                    break;
                case 4://*************M16****************
                    r.setRotation(Math.atan2(my - a1.getY(),mx-a1.getX())+Math.PI/2); 
                    if(Greenfoot.mousePressed(null) && mouse.getButton()==1 && !grabbing){
                        shooting = true;
                    }
                    if(Greenfoot.mouseClicked(null)){
                        shooting = false;
                        soundCounter = 0;
                    }
                    shotCooldown--;
                    if(shooting && shotCooldown<=0){
                        shotCooldown = 4;
                        if(ammo[2]==0){
                            Greenfoot.playSound("Weapons/Empty.mp3");
                            shooting = false;
                        }else{
                            world.addObject(muzzleFlashImage,r.myX + 25*Math.sin(r.angle),r.myY - 25*Math.cos(r.angle));
                            if(Math.random()>.35){
                                muzzleFlashImage.getImage().mirrorVertically();
                            }
                            muzzleFlashImage.setRotation(r.angle + Math.PI/2);
                            muzzleFlashImage.updateWorldLocation();
                            reloadBullets = 0;
                            muzzleFlash = 1f;
                            ammo[2]--;
                            if(soundCounter==0){
                                Greenfoot.playSound("Weapons/M16_Fire.mp3");
                            }
                            double angleOffset = (Math.random()-.5)/4;
                            soundCounter++;
                            if(soundCounter>1){
                                soundCounter = 0;
                            }
                            world.addObject(new bullet(Math.cos(angleOffset+r.angle-Math.PI/2)*15,Math.sin(angleOffset+r.angle-Math.PI/2)*15,7.2),
                                                       r.myX+Math.cos(r.angle-Math.PI/2)*15,
                                                       r.myY+Math.sin(r.angle-Math.PI/2)*15);
                            rotate(angleOffset*2);
                        }
                    }
                    break;
                case 5://*************SHOTGUN****************
                    r.setRotation(Math.atan2(my - a1.getY(),mx-a1.getX())+Math.PI/2); 
                    shotCooldown--;
                    if(Greenfoot.mousePressed(null) && mouse.getButton()==1 && !grabbing){
                        if(ammo[3]==0 || shotCooldown>0){
                            if(ammo[3]==0)Greenfoot.playSound("Weapons/Empty.mp3");
                        }else{
                            shotCooldown = 40;
                            world.addObject(muzzleFlashImage,r.myX + 25*Math.sin(r.angle),r.myY - 25*Math.cos(r.angle));
                            if(Math.random()>.35){
                                muzzleFlashImage.getImage().mirrorVertically();
                            }
                            muzzleFlashImage.setRotation(r.angle + Math.PI/2);
                            muzzleFlashImage.updateWorldLocation();
                            reloadBullets = 0;
                            muzzleFlash = 1f;
                            ammo[3]--;
                            Greenfoot.playSound("Weapons/Shotgun_Fire.mp3");
                            for(int i=0;i<10;i++){
                                double angleOffset = (Math.random()-.5)/2;
                                double tempVel = 13+(Math.random());
                                world.addObject(new bullet(Math.cos(angleOffset+r.angle-Math.PI/2)*tempVel,Math.sin(angleOffset+r.angle-Math.PI/2)*tempVel,5),
                                                          r.myX+Math.cos(r.angle-Math.PI/2)*tempVel,
                                                          r.myY+Math.sin(r.angle-Math.PI/2)*tempVel);
                            }
                            rotate(1);
                        }
                    }
                    break;
                default:
                    if(angle-mang>0){
                        a1.setRotation(angle);
                    }else{
                        a1.setRotation(mang+Math.sin(axeAnimation));
                    }
                    r.setRotation(mang); 
                    break;
            }     
        }else{
           s1.setImageOffset(0,3*Math.sin(inc+Math.PI));
        }
        if(muzzleFlash>0){
            muzzleFlash -= .3;
        }
        if(muzzleFlash<0){
            muzzleFlash = 0;
            world.removeObject(muzzleFlashImage);
        }
    }
    
    public void switchWeapon(int type){
        weaponType = type;
        reloadBullets = 0;
        switch(type){
            case 1: r.setImage("Characters/Weapon_Axe.bmp");break;
            case 2: r.setImage("Characters/Weapon_Pistol.bmp");break;
            case 3: r.setImage("Characters/Weapon_Magnum.bmp");break;
            case 4: r.setImage("Characters/Weapon_M16.bmp");break;
            case 5: r.setImage("Characters/Weapon_Shotgun.bmp");break;
            default: r.setImage("Characters/Weapon_Axe.bmp");break;
        }   
        //world.previewWeapon(type);
        r.clearImage();
        if(type>weaponMax){
            weaponMax = type;
        }
    }
     
    public boolean keep(){
        return true;
    }
    
    public double[] getShadowX(){
        return shadowX;
    }
    
    public double[] getShadowY(){
        return shadowY;
    }
    
    public void hurt(double dx,double dy,double h){
        if(health>0){
            world.lightShadow.setRedAlpha();
        }
        velx += dx;
        vely += dy;
        if(safeTime<0){
            health -= h;
            safeTime = 20;
        }
    }
    
    public void grabbed(ActionActor obj){
        grabbedObject = obj;
        grabbing = true;
        usePressed = false;
    }
    
    public void grabFlare(Flare f){
        currentFlare = f;
        hasFlare = true;
    }
    
    public double grabbedDistance(){
        if(grabbedObject==null){
            return 0;
        }
        double ret = distTo(grabbedObject.myX,grabbedObject.myY);
        return ret;
    }
    
    public void releaseObject(){
        grabbing = false;
        grabbedObject.release();
    }
    
    public void releaseFlare(){
        hasFlare = false;
        currentFlare.release();
        currentFlare = null;
    }
    
    public boolean holdingFlare(){
        return hasFlare;
    }
    
    public void force(double x,double y){
        velx += x;
        vely += y;
    }
    
    public void heal(int h){
        health += h;
        if(health>60){
            health = 60;
        }
    }
}
