import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Write a description of class BloodSplatter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BloodSlide  extends ActionActor
{
    GreenfootImage image;
    double[] bx,by,bxv,byv,bs;
    int ang;
    
    public BloodSlide(int l,int w,int a,int n){
        image = new GreenfootImage(w,l);
        setImage(image);
        ang = a;
        bx = new double[n];
        by = new double[n];
        bxv = new double[n];
        byv = new double[n];
        bs = new double[n];
        for(int i=0;i<n;i++){
            by[i] = Math.random()*w*.4 + .3*w;
            bx[i] = .4*(Math.random()*w)+.3*w;
            bs[i] = Math.random()*3;
        }
        for(int j=0;j<l;j++){
            for(int i=0;i<bx.length;i++){
                double s = (bs[i]*(double)(l-j))/((double)l);
                double y = by[i]+j;
                image.setColor(new Color(128-(int)(bs[i]*40)+100,128-(int)(bs[i]*40),128-(int)(bs[i]*40),70));
                image.fillRect((int)(bx[i]-.5*s+Math.random()*.7 + Math.pow((j)/((double)l),2)*50),(int)(y-.5*s),(int)s,(int)s);
            }
        }
        for(int i=0;i<n;i++){
            double ang = Math.random()*Math.PI*2;
            double r = Math.random()*(w/2-5);
            double x = Math.cos(ang)*r + w/2;
            double y = Math.sin(ang)*r + w/2;
            for(int j=0;j<n;j++){
                image.setColor(new Color(128,0,0,8));
                image.fillRect((int)(x+Math.random()*10 - 5),(int)(y+Math.random()*10 - 5),3,3);
            }
        }
        
        
    }
    
    protected void addedToWorld(World world){
        setRotation(ang);
        super.addedToWorld(world);
    }
 
}
