import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;


public class BloodSmears  extends ActionActor
{
    

    public BloodSmears(int l,int w,int smears,int n,double length){
        setImage( new GreenfootImage(w,l) );
        for(int i=0;i<smears;i++){
            double x = Math.random()*(w-length*2)+length;
            double y = Math.random()*(w-length)+length;
            double ang = Math.random()*Math.PI*2;
            double r = Math.random()*(length-5)+5;
            double size = Math.random()*3+2;
            for(int j=0;j<n;j++){
                getImage().setColor(new Color(128,0,0,30));
                double lr = Math.random();
                getImage().fillOval((int)(x-size/2+r*Math.cos(ang)*lr+Math.random()*6-3),(int)(y-size/2+r*Math.sin(ang)*lr+Math.random()*6-3),(int)size,(int)size);
            }
            
        }
    }
    
    public void act() 
    {
        super.act();
    }    
}
