import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;
/**
 * Write a description of class BloodSplatter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BloodSplatter  extends ActionActor
{
    GreenfootImage image;
    double[] bx,by,bxv,byv,bs;
    
    public BloodSplatter(int r,int n){
        image = new GreenfootImage(r,r);
        setImage(image);
        bx = new double[n];
        by = new double[n];
        bxv = new double[n];
        byv = new double[n];
        bs = new double[n];
        for(int i=0;i<n;i++){
            bx[i] = r/2;
            by[i] = r/2;
            double ang = Math.random()*Math.PI*2;
            double size = Math.random()*(r*.1);
            bxv[i] = Math.cos(ang)*.8;
            byv[i] = Math.sin(ang)*.8;
            bs[i] = size;
        }
    }
    
    public void act() 
    {
        for(int i=0;i<bx.length;i++){
            if(bs[i]>0){
                image.setColor(new Color(128,0,0,20));
                image.fillOval((int)bx[i],(int)by[i],(int)bs[i],(int)bs[i]);
                bx[i] += bxv[i]+(Math.random()-.5)*2;
                by[i] += byv[i]+(Math.random()-.5)*2;
                bs[i] -= Math.random()*.2;
            }
        }
        super.act();
    }    
}
