import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Connector here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Connector  extends ActionActor
{
    Connector friend;
    boolean isMaster = false;
    double sx,sy,sang;
    double myang;
    
    double dx,dy;
    
    boolean isConnected = false;
    Cable connection;
    
    public Connector(double x,double y,double ang,double my){
        isMaster = true;
        friend = new Connector();
        sx = x;
        sy = y;
        sang = ang;
        myang = my;
    }
    
    public Connector(){
        isMaster = false;
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        if(isMaster){
            world.addObject(friend,sx,sy);
            friend.friend = this;
            friend.setRotationDegrees(sang);
            setRotationDegrees(myang);
            friend.dx = -Math.cos(sang/180.0*Math.PI);
            friend.dy = -Math.sin(sang/180.0*Math.PI);
            dx = -Math.cos(myang/180.0*Math.PI);
            dy = -Math.sin(myang/180.0*Math.PI);
        }
        clearImage();
    }
    
    public void act(){
        super.act();
        actionNumber = 0;
        if(isConnected && friend.isConnected && (friend.connection==connection.slave || friend.connection==connection.master)){
            actionNumber = 2;
        }   
    }
    
    public boolean action(int a){
        //System.out.println(a + "::::");
        actionNumber = a;
        switch(a){
            case 4:connection.lock();return true;
        }
        return false;
    }
    
    
    
    public void connect(Cable c){
        connection = c; 
        isConnected = true;
    }
    
    public void disconnect(){
        isConnected = false;
    }
    
    public boolean isConnected(){
        return isConnected;
    }
}
