import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Grim here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Grim extends Character
{
    bodyPartAbove jaw1;
    bodyPartAbove jaw2;
    static GreenfootImage j1 = new GreenfootImage("Monsters/Grim/Jaw1.png");
    //static GreenfootImage j2 = new GreenfootImage("Monsters/Grim/Jaw2.png");
    //StaticImage jaw2 = new StaticImage(j2);
    double counter = 0;
    double jawAngle = .2;
    int state = 0;  //0 = waiting
                    //1 = snapping closed
   
    
    public Grim(){
        super(0,0);
        jaw1 = new bodyPartAbove(this,-50,40,"Monsters/Grim/Jaw1.png");  
        jaw2 = new bodyPartAbove(this,-50,-40,"Monsters/Grim/Jaw2.png");  
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        world.addObject(jaw1,myX,myY);
        world.addObject(jaw2,myX,myY);
        setRotation(-Math.PI/2);
    }
    
    
    public void act() 
    {
        counter += .1;
        jaw1.setLocalRotation(-jawAngle);
        jaw2.setLocalRotation(jawAngle);
        jaw1.setImageOffset(-50,Math.sin(jawAngle)*130+40);
        jaw2.setImageOffset(-50,-Math.sin(jawAngle)*130-40);
        if(state==1){
            snapClosed();
        }
        if(state==2){
            openJaw();
        }
        
        move(0,0);
        super.act();
    }    
    
    public void snapClosed(){
        if(jawAngle>0){
            jawAngle -= .05;
        }else{
            Greenfoot.playSound("Monsters/Grim/Chomp.mp3");
            //Greenfoot.playSound("Monsters/Grim/Growl1.mp3");
            state = 0;
        }
    }
    
    public void openJaw(){
        if(jawAngle<.2){
            jawAngle += .002;
        }       
    }
    
    public int radius(){
        return (int)(Math.cos(jawAngle*7)*260);
    }
    
    public boolean action(int a){
        actionNumber = a;
        switch(a){
            case 2:state = 1;return true;
            case 6:state = 2;return true;
        }
        return false;
    }
    
    public void seek(double x,double y,double s){
        double mag = dist(x-myX,y-myY);
        move((x-myX)*s/mag,(y-myY)*s/mag);
        if(mag<s){
            myX = x;
            myY = y;
        }
    }
}
