import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Character here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Person extends Character
{
    //Body Parts
    bodyPartBelow f1;
    bodyPartBelow f2;
    bodyPartAbove h;
    bodyPartBelow a1;
    bodyPartBelow a2;
    bodyPartBelow l;
    bodyPartBelow g;
    bodyPartBelow s1;
    bodyPartBelow s2;
    
    MouseInfo mouse;
    int mx,my;
    double mang;
    
    double inc = 0;
    double ang;
    double strafe;
    double speed = .14;   //should be .2
    double step;
    double travelAng;

    boolean flashlight = false;
    boolean weapon = false;
    
    boolean pressed = false;
    
    boolean usePressed = false;
    Tester tester = new Tester();
    
    double[] shadowX = {-9,9,9,-9};
    double[] shadowY = {-2,-2,2,2};
    int shadow = 2;
    
    double deltaX=0,deltaY=0;
    
    int health = 30;
    int safeTime = 0;

    public Person(String type){
        super(0,0);
        setImage(new GreenfootImage("Characters/Body_"+type+".bmp"));
        f1 = new bodyPartBelow(this,0,0,"Characters/Shoe.bmp");
        f2 = new bodyPartBelow(this,0,0,"Characters/Shoe.bmp");
        //g = new bodyPartBelow(a1,a+11,b-7,0,-6,"Gun.bmp");
        h = new bodyPartAbove(this,0,0,"Characters/Head_"+type+".bmp");
        s1 = new bodyPartBelow(this,0,0,"Characters/Shoulder.bmp");
        s2 = new bodyPartBelow(this,0,0,"Characters/Shoulder.bmp");  
    }
    
    protected void addedToWorld(World w){
        super.addedToWorld(w);
        world.addObject(f1,myX+6,myY);
        world.addObject(f2,myX-6,myY);
        world.addObject(h,myX,myY);
        world.addObject(s1,myX+11,myY);
        world.addObject(s2,myX-11,myY);
        world.addObject(tester,0,0);
        mass = 10000;
    }
    
    public int isShadow(){
        return shadow;
    }
    
    public double[] getShadowX(){
        return shadowX;
    }
    
    public double[] getShadowY(){
        return shadowY;
    }
    
    

    public void act() 
    {
        //inc += .2;
        safeTime--;
        mouse = Greenfoot.getMouseInfo();
        if(mouse!=null){
            mx = mouse.getX();
            my = mouse.getY();
        }
        
        
        f1.setImageOffset(0,6*Math.sin(inc)-1);
        f2.setImageOffset(0,-6*Math.sin(inc)-1);
        velx += deltaX;
        vely += deltaY;
            
        mang = Math.atan2(my-200,mx-200) + Math.PI/2;
        ang = mang;
        
        if(pressed){
            travelAng = Math.atan2(deltaY,deltaX)+Math.PI/2;
            inc += .12*Math.sqrt(velx*velx + vely*vely);
            double temp = Math.atan2(vely,velx)+Math.PI/2 - ang;
            if(temp>Math.PI)
                temp -= Math.PI*2;
            if(temp<-Math.PI)
                temp += Math.PI*2;
            if(temp>Math.PI)
                temp -= Math.PI*2;
            if(temp<-Math.PI)
                temp += Math.PI*2;
            if(temp<-3*Math.PI/4)
                temp += 5*Math.PI/4;
            if(temp>3*Math.PI/4)
                temp -= 5*Math.PI/4;
            step = temp;
            temp = temp/2;
            temp += ang;
            step = ang;
            ang = temp;
        }else{
            inc += (-inc)/15;
            step = ang;
        }
        if(inc>Math.PI*2)
            inc -= Math.PI*2;
            
        
        if(Math.abs(angle-(Math.PI*2+ang)) < Math.abs(angle-ang)){
            ang = ang+Math.PI*2;
        }
        if(Math.abs(angle-(-Math.PI*2+ang)) < Math.abs(angle-ang)){
            ang = ang-Math.PI*2;
        }

        //setRotation(ang/2);
        if(Math.abs(angle-(Math.PI*2+mang)) < Math.abs(angle-mang)){
            mang = mang+Math.PI*2;
        }
        if(Math.abs(angle-(-Math.PI*2+mang)) < Math.abs(angle-mang)){
            mang = mang-Math.PI*2;
        }    
        
        
        if(flashlight){
            world.setLightBeam((int)l.myX,(int)l.myY,angle/Math.PI*180-90);
            world.setLightShadow((int)myX,(int)myY);
            if(angle-mang>0){
                a2.setRotation(angle);
            }else{
                a2.setRotation(angle);
            }
            l.setRotation(angle);
            strafe = .03*Math.sin(inc);
            towards(strafe+travelAng);
            h.setRotation(angle);
        }else{   
            strafe = .4*Math.sin(inc);
            towards(strafe+travelAng);
            h.setRotation(angle);
            s2.setImageOffset(0,3*Math.sin(inc)-2);    
        }
        s1.setImageOffset(0,3*Math.sin(inc+Math.PI)-2);
          
        if(angle>Math.PI/2)
            rotate(-2*Math.PI);
        if(angle<-Math.PI)
            rotate(2*Math.PI);

        pressed = false;
        deltaX=0;
        deltaY=0;  
        super.act();
        
    } 
    
    public void towards(double tang){
       if(Math.abs(angle-(Math.PI*2+tang)) < Math.abs(angle-tang)){
           tang = tang+Math.PI*2;
       }
       if(Math.abs(angle-(-Math.PI*2+tang)) < Math.abs(angle-tang)){
           tang = tang-Math.PI*2;
       } 
       rotate((tang - angle)/8);
    }
    
    public boolean action(int a){
        actionNumber = a;
        switch(a){
            case 2: giveFlashlight();return true;
        }
        return false;
    }
    
    public void giveFlashlight(){
        flashlight = true;      
        getWorld().removeObject(s2);
        removeChild(s2);
        //addChild(a1);
        //a1.addChild(l);
        //a1 = new bodyPartBelow(this,centerX+11,centerY,0,-4,"Arm.bmp");
        a2 = new bodyPartBelow(this,0,-4,"Characters/Arm.bmp");
        //h = new bodyPartAbove(a1,centerX,centerY,0,0,"Head.bmp");
        l = new bodyPartBelow(a2,0,-7,"Characters/Light.bmp");
        world.addObject(a2,myX-11,myY);
        world.addObject(l,myX-11,myY-7);
        shadow = 0;
    }
    
    public int lightX(){
        return l.getX();
    }
    
    public int lightY(){
        return l.getY();
    }
    
    public void seek(double a,double b,double s){
        pressed = true;
        if(myX>a+3){
            deltaX = -speed*s;
        }
        if(myX<a-3){
            deltaX = speed*s;
        }
        if(myY>b+3){
            deltaY = -speed*s;
        }
        if(myY<b-3){
            deltaY = speed*s;
        }
    }
    
    public boolean isNear(){
        return Math.abs(myX-destX.get(0))<5   &&  Math.abs(myY-destY.get(0))<5;
    }
    
    public void hurt(double dx,double dy,double mag){
        if(safeTime<0){
            health -= mag;
            safeTime = 20;
        }
        velx += dx;
        vely += dy;
        if(health <= 0){
            List<Bone> all = getConnectedBones();   
            for(int i=0;i<all.size();i++){
                world.addObject(new shrapnel(all.get(i),0,0,2,false),myX,myY);
            }  
            world.addObject(new BloodSplatter(80,40),myX,myY);
            removeAllBones();
            //Greenfoot.playSound("Zombie_die"+(Greenfoot.getRandomNumber(2)+1)+".mp3");
        }
        actionNumber = 3;
    }
    
    public void force(double x,double y){
        velx += x;
        vely += y;
    }
    
    @Override 
    public void rotateDegrees(double a){
        travelAng += a/180.0*Math.PI;
    }
    
    @Override
    public boolean isIntersectingWall(){
        return world.tileSolid(myX+getImage().getWidth()/2,  myY+getImage().getHeight()/2 , 2) || 
               world.tileSolid(myX+getImage().getWidth()/2,  myY-getImage().getHeight()/2 , 2) || 
               world.tileSolid(myX-getImage().getWidth()/2,  myY+getImage().getHeight()/2 , 2) || 
               world.tileSolid(myX-getImage().getWidth()/2,  myY-getImage().getHeight()/2 , 2);
    }
    
}