import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class StaticImage here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class StaticImage  extends ActionActor
{
    boolean hasFlashlight = false;
    boolean smooth = false;
    double velX,velY;
    
    public StaticImage(){
    }
    
    public StaticImage(GreenfootImage i){
        setImage(i);
        clearImage();
    }
    
    public StaticImage(String image){
        setImage(new GreenfootImage(image));
        clearImage();
    }
    
    protected void addedToWorld(World w){
        world = (world)w;
        act();
    }
    
    public void act() 
    {
        super.act();
        if(hasFlashlight){
            world.setLightShadow(getX()+(int)world.tilex,getY()+(int)world.tiley);
            world.setLightBeam(getX()+(int)world.tilex,getY()+(int)world.tiley,getRotation()+180);
        }
        move(velX,velY);
        //System.out.println(velX);
        if(!smooth){
            velX = 0;
            velY = 0;
        }else{
            velX *= .9;
            velY *= .9;
        }
    } 
    
    public void seek(double x,double y,double s){
        double mag = dist(x-myX,y-myY);
        if(mag<s){
            myX = x;
            myY = y;
            return;
        }
        velX = (x-myX)*s/mag;
        velY = (y-myY)*s/mag;    
    }
    
    public boolean action(int a){
        actionNumber = a;
        if(a==2){
            hasFlashlight = true;return true;    
        }
        if(a==3){
            smooth = true;return true;
        }
        return false;
    }
    
    
}
