import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

public class TriggerSelection extends Trigger
{
    world world;
    ArrayList<Trigger> triggers = new ArrayList<Trigger>();
    int selections;
    
    public TriggerSelection(int s,EventScript p){
        //selections = s;
        setParent(p);
        selections = s;
    }
    
    protected void addedToWorld(World w){
        for(int i=0;i<selections;i++){
            int remove = Greenfoot.getRandomNumber(triggers.size());
            ((world)w).removeObject(triggers.get(remove));
            triggers.remove(remove);
            //System.out.println(i);
        }  
        ((world)w).removeObject(this);
        //System.out.println("hooo");
    }
    
    public void addTrigger(Trigger t){
        triggers.add(t);
    }
}
