import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.image.BufferedImage;
import java.awt.Graphics2D;
import java.awt.AlphaComposite;
import java.awt.Composite;
import java.awt.Rectangle;
import java.awt.Polygon;
import java.awt.Color;



public class shrapnel  extends ActionActor
{

    double velx,vely,velang;
    int timer = 500;


    public shrapnel(Actor a,double strength,double angle,double spread,boolean fragment){
        setImage(new GreenfootImage(a.getImage()));
        double ang = angle;
        strength *= Math.random() + .5;
        velx = strength*Math.cos(ang) + (Math.random()-.5)*spread;
        vely = strength*Math.sin(ang) + (Math.random()-.5)*spread;
        velang = Math.random()*strength*4;    
    }
        
    public shrapnel(Actor a,double strength,double angle, double spread){
        setImage(new GreenfootImage(a.getImage()));
        
        BufferedImage buffer = getImage().getAwtImage();
        Graphics2D graphics = buffer.createGraphics();
        AlphaComposite alpha0 = AlphaComposite.getInstance(AlphaComposite.CLEAR);
        Composite backup;
        backup = graphics.getComposite();
        graphics.setComposite(alpha0);
        int[] x1 = new int[6];
        int[] y1 = new int[6];
        for(int i=0;i<5;i++){
            for(int j=0;j<x1.length;j++){
                x1[j] = Greenfoot.getRandomNumber(getImage().getWidth()*2) - getImage().getWidth()/2;
                y1[j] = Greenfoot.getRandomNumber(getImage().getHeight()*2) - getImage().getHeight()/2;
            }
            Polygon poly = new Polygon(x1,y1,x1.length);
            graphics.fill(poly);
        }
        graphics.setComposite(backup);
        double ang = angle;
        strength *= Math.random() + .5;
        velx = strength*Math.cos(ang) + (Math.random()-.5)*spread;
        vely = strength*Math.sin(ang) + (Math.random()-.5)*spread;
        velang = Math.random()*strength*4;    
    }
    
    
    
    public void act() 
    {     
        move(velx,vely);
        rotate(velang);
        velx *= .95;
        vely *= .95;
        velang *= .95;
        timer--;
        super.act();
        if(timer<256){
            getImage().setTransparency(timer);
        }
        if(timer == 0){
            world.removeObject(this);
        }       
    }    
}
